#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.14.5
 Author: SHDF/CETIPABO

 Script Function:
	Interroge l'API de la livebox

#ce ----------------------------------------------------------------------------

#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Json.au3>
#Region ### START Koda GUI section ### Form=
$Form1 = GUICreate("JsonLiveBox V1.0", 615, 437, 192, 124)
$Group1 = GUICtrlCreateGroup("Paramtres de connexion", 16, 16, 577, 89)
$Label1 = GUICtrlCreateLabel("User :", 32, 40, 32, 15)
$Input1 = GUICtrlCreateInput("admin", 32, 56, 121, 21)
$Label2 = GUICtrlCreateLabel("Password :", 168, 40, 56, 15)
$Input2 = GUICtrlCreateInput("", 168, 56, 121, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_PASSWORD))
$Label3 = GUICtrlCreateLabel("IP Livebox", 304, 40, 54, 15)
$Input3 = GUICtrlCreateInput("192.168.1.1", 304, 56, 121, 21)
$Button1 = GUICtrlCreateButton("Envoi", 448, 56, 75, 21)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Group2 = GUICtrlCreateGroup("Requte Json  envoyer", 16, 120, 577, 65)
$Input4 = GUICtrlCreateInput("", 32, 144, 545, 21)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Group3 = GUICtrlCreateGroup("Rponse Livebox", 16, 200, 577, 217)
$Edit1 = GUICtrlCreateEdit("", 32, 224, 545, 177, BitOR($ES_AUTOVSCROLL,$ES_WANTRETURN,$WS_VSCROLL))
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

Global $cookie, $LIVEBOX, $PASSWORD, $USER, $sContextID, $connexion


$oHTTP = ObjCreate("winhttp.winhttprequest.5.1")

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			if ($nMsg = $GUI_EVENT_CLOSE) then
				if ($sContextID <>"") Then
					; Logout si on est connect
					$PARAMS = '{"service":"sah.Device.Information","method":"releaseContext","parameters":{"applicationName":"so_sdkut"}}'
					$oHTTP.Open("POST", "http://" & $LIVEBOX & "/ws", False)
					$oHTTP.SetRequestHeader("Content-Type", "application/x-sah-ws-4-call+json")
					$oHTTP.SetRequestHeader("X-Context", $sContextID)
					$oHTTP.SetRequestHeader("cookie", $cookie & "; sah/contextId=" & $sContextID)
					$oHTTP.Send($PARAMS)
					$oHTTP = 0
				Exit
				Else
					exit
				endif
			EndIf

		Case $Button1
			$LIVEBOX = GUICtrlRead($Input3)
			$USER = GUICtrlRead($Input1)
			$PASSWORD = GUICtrlRead($Input2)

			auth_livebox()

			if $connexion=="OK" Then

				; Envoi de la Requete
				$PARAMS = GUICtrlRead($Input4)
				$oHTTP.Open("POST", "http://" & $LIVEBOX & "/ws", False)
				$oHTTP.SetRequestHeader("Content-Type", "application/x-sah-ws-4-call+json")
				$oHTTP.SetRequestHeader("X-Context", $sContextID)
				$oHTTP.SetRequestHeader("cookie", $cookie & "; sah/contextId="&$sContextID)
				$oHTTP.Send($PARAMS)
				$getRequest = $oHTTP.ResponseText

				GUICtrlSetData($Edit1,$getRequest)

			EndIf

	EndSwitch
WEnd



Func auth_livebox()
	; On vrifie que la Livebox est bien sur l'IP indique et qu'elle rpond
	$iplivebox = StringSplit($LIVEBOX,":")
	$ping = ping($iplivebox[1])
	if $ping = 0 then
		MsgBox(0,'Erreur de connexion',"La Livebox n'est pas joignable sur l'IP : " & $LIVEBOX)

	Else

	$PARAMSlogin = '{"service":"sah.Device.Information","method":"createContext","parameters":{"applicationName":"so_sdkut","username":"'& $USER &'","password":"' & $PASSWORD & '"}}'

	$oHTTP.Open("POST", "http://" & $LIVEBOX & "/ws", False)
	$oHTTP.SetRequestHeader("Content-Type", "application/x-sah-ws-4-call+json")
	$oHTTP.SetRequestHeader("Authorization", "X-Sah-Login")
	$oHTTP.Send($PARAMSlogin)
	$oReceived = $oHTTP.ResponseText
	$sResult = Json_Decode($oReceived)
	$sContextID = Json_Get($sResult, '["data"]["contextID"]')
		If $sContextID == "" Then
			MsgBox(48, "ERREUR", "aucun ContextID reu, erreur d'authentification")
			$connexion = ""
		Else
		$cookie = $oHTTP.getResponseHeader("Set-Cookie")
		$connexion = "OK"
		EndIf
	EndIf

EndFunc   ;==>auth_livebox